#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libusb-1.0/libusb.h>

#define USB_MAX_INTERFACES 8
#define USB_CONTROL_TIMEOUT	100
#define USB_BULK_TIMEOUT 1000
//#define USB_DEBUG 1


/* http://www.beyondlogic.org/usbnutshell/usb6.shtml */

struct usb_device
{
 uint16_t vendor;
 uint16_t product;

 libusb_device_handle *device;

 uint8_t interfaces;
 uint8_t kernel[USB_MAX_INTERFACES];
 uint8_t claimed[USB_MAX_INTERFACES];
};

struct usb_transfer
{
 unsigned char endpoint;
 uint8_t recipient;
 uint8_t type;

 uint8_t request;
 uint16_t value;
 uint16_t index;

 unsigned char *data;
 uint16_t length;
};


void usb_close(struct usb_device *dev);
int usb_open(struct usb_device *dev, uint8_t interfaces);

void usb_transfer_reset(struct usb_transfer *transfer, uint16_t length, const unsigned char *data);

int usb_control(struct usb_device *dev, struct usb_transfer *transfer);
int usb_bulk(struct usb_device *dev, struct usb_transfer *transfer);
